$ !----------------------------------------------------------------------------
$ !     CLEAN_VMSMAIL.COM       -- This program will scan the VMSMAIL_PROFILE
$ !             and search for unused entries in the file.  If a SYSUAF record
$ !             does not exist for a file, then a check is made to determine
$ !             if the account has been forwarded to another account.  If
$ !             the account is forwarded, the validity of the forwarding is
$ !             checked using the DECnet MAIL-11 object.
$ !
$ !             Obsolete entries in the VMSMAIL_PROFILE are deleted.
$ !
$ ! Author:     David L. Cathey, Montagar Software Concepts
$ !             P. O. Box 260772
$ !             Plano, TX  75026-0772
$ !             davidc@montagar.com
$ !
$ ! Date:       12-MAR-1991
$ ! Last Upd:   6-AUG-1991
$ !
$ close/nolog net_mail
$ close/nolog uaf_file          ! Close all files...
$ close/nolog vms_mail
$ close/nolog vms_mail2
$ ! Open mail and SYSUAF files...
$ open/read/share=write vms_mail -
        'f$parse("VMSMAIL_PROFILE","SYS$SYSTEM:VMSMAIL_PROFILE.DATA")'
$ open/write/read/share=write vms_mail2 -
        'f$parse("VMSMAIL_PROFILE","SYS$SYSTEM:VMSMAIL_PROFILE.DATA")'
$ open/read/share=write uaf_file -
        'f$parse("SYSUAF","SYS$SYSTEM:SYSUAF.DAT")'
$ !
$ ! Main Loop, get all entries from the profile...
$ !
$ loop:
$ read/end=finis vms_mail record
$ username = f$edit(f$extract(0,31,record),"COLLAPSE")
$ ! Check UAF file...
$ read/key="''username'"/error=no_uaf uaf_file uaf_rec
$ goto loop                     ! SYSUAF record exists, skip this one...
$ !
$ ! No SYSUAF entry, look for possible forwarding...
$ !
$ no_uaf:
$ write sys$output " "
$ write sys$output "''username' - No authorization record"
$ ! Check for mail fowarding...
$ position = 31
$ forward_loop:                 ! Find forwarding subrecord (type = 4)
$ result = f$extract(position,f$length(record),record)
$ if f$length(result) .eq. 0 then $ goto no_forward
$ if f$cvui(0,16,result) .eq. 4 then $ goto check_forward
$ position = position + f$cvui(16,16,result) + 4
$ goto forward_loop
$ !
$ ! Found forwarding subrecord...
$ !
$ check_forward:
$ ! Check the validity of the receipient address via DECnet MAIL-11
$ forward = f$extract(4,f$cvui(2*8,16,result),result)
$ close/nolog net_mail
$ open/read/write/error=for_abort net_mail 0::"MAIL=" /error=for_abort
$ write /error=for_abort net_mail "''f$getjpi("","USERNAME")'"
$ write /error=for_abort net_mail forward
$ read  /error=for_abort net_mail status
$ stat = f$cvui(0,32,status)
$ if stat then $ goto for_okay
$ ! Invalid forwarding address, flag and delete this record...
$ write sys$output "''username' - Invalid forwarding address ",forward
$ goto delete_record
$ !
$ ! Error checking forwarding, assume success...
$ !
$ for_abort:
$ stat = $status
$ write sys$output "''username' - Error checking forwarding: ''f$message(stat)'"
$ !
$ ! Forward address seems to check out...
$ !
$ for_okay:
$ if stat then -
        $ write sys$output "''username' - Forward to ",forward," okay..."
$ goto loop
$ !
$ ! No forwarding information found
$ !
$ no_forward:
$ write sys$output "''username' - No forwarding address"
$ !
$ ! Delete the offending record...
$ !
$ delete_record:
$ ! Delete VMSMAIL information
$ write sys$output "''username' - Deleting VMSMAIL record"
$ read/key="''username'"/delete vms_mail2 record
$ goto loop
$ !
$ ! Operation complete, perform cleanup...
$ !
$ finis:
$ close/nolog net_mail
$ close/nolog uaf_file
$ close/nolog vms_mail
$ close/nolog vms_mail2
$ exit
